      COMPLEX FUNCTION CERROR(X,Y)
c
C  SIXTH-ORDER APPROX TO THE COMPLEX ERROR FUNCTION OF X+i*Y.
C  Y MUST BE POSITIVE.
C  REFERENCE FOR EQUATIONS:
C      HUI, ARMSTRONG AND WRAY, JQSRT V.19, P.509 (1978).
C
C     P. ROSENKRANZ  2/19/88
C
      REAL X,Y
      COMPLEX A,B,ZH
      ZH = CMPLX(Y,-X)
      A = (((((.5641896*ZH+5.912626)*ZH+30.18014)*ZH+
     & 93.15558)*ZH+181.9285)*ZH+214.3824)*ZH+122.6079
      B = ((((((ZH+10.47986)*ZH+53.99291)*ZH+170.3540)*ZH+
     & 348.7039)*ZH+457.3345)*ZH+352.7306)*ZH+122.6079
      CERROR = A/B
      RETURN
      END
